aboutsummaryrefslogtreecommitdiff
path: root/paludis/repositories/e/ebuild/die_functions.bash
diff options
context:
space:
mode:
authorAvatar Ciaran McCreesh <ciaran.mccreesh@googlemail.com> 2007-06-28 21:45:56 +0000
committerAvatar Ciaran McCreesh <ciaran.mccreesh@googlemail.com> 2007-06-28 21:45:56 +0000
commit45692e817c0a0c4b4f2ebc91501987efecff23aa (patch)
treeaf997ccbbb94eda5b55271ac1ba763ac49dc5540 /paludis/repositories/e/ebuild/die_functions.bash
parente73fa3ac11891c1db89e1a600b1edeb9395d86c9 (diff)
downloadpaludis-45692e817c0a0c4b4f2ebc91501987efecff23aa.tar.gz
paludis-45692e817c0a0c4b4f2ebc91501987efecff23aa.tar.xz
r3634@snowflake: ciaranm | 2007-06-28 22:45:19 +0100
We'll call it 'E', not 'Gentoo'
Diffstat (limited to 'paludis/repositories/e/ebuild/die_functions.bash')
-rw-r--r--paludis/repositories/e/ebuild/die_functions.bash58
1 files changed, 58 insertions, 0 deletions
diff --git a/paludis/repositories/e/ebuild/die_functions.bash b/paludis/repositories/e/ebuild/die_functions.bash
new file mode 100644
index 000000000..cfff825c4
--- /dev/null
+++ b/paludis/repositories/e/ebuild/die_functions.bash
@@ -0,0 +1,58 @@
+#!/bin/bash
+# vim: set sw=4 sts=4 et :
+
+# Copyright (c) 2006, 2007 Ciaran McCreesh <ciaranm@ciaranm.org>
+#
+# Based in part upon ebuild.sh from Portage, which is Copyright 1995-2005
+# Gentoo Foundation and distributed under the terms of the GNU General
+# Public License v2.
+#
+# This file is part of the Paludis package manager. Paludis is free software;
+# you can redistribute it and/or modify it under the terms of the GNU General
+# Public License, version 2, as published by the Free Software Foundation.
+#
+# Paludis is distributed in the hope that it will be useful, but WITHOUT ANY
+# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
+# details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place, Suite 330, Boston, MA 02111-1307 USA
+
+EBUILD_KILL_PID=$$
+declare -r EBUILD_KILL_PID
+
+alias die='diefunc "$FUNCNAME" "$LINENO"'
+alias assert='_pipestatus="${PIPESTATUS[*]}"; [[ -z "${_pipestatus//[ 0]/}" ]] || diefunc "$FUNCNAME" "$LINENO" "$_pipestatus"'
+trap 'echo "die trap: exiting with error." 1>&2 ; exit 250' 15
+
+diefunc()
+{
+ local func="$1" line="$2"
+ shift 2
+ echo 1>&2
+ echo "!!! ERROR in ${CATEGORY:-?}/${PF:-?}:" 1>&2
+ echo "!!! In ${func:-?} at line ${line:-?}" 1>&2
+ echo "!!! ${*:-(no message provided)}" 1>&2
+ echo 1>&2
+
+ echo "!!! Call stack:" 1>&2
+ for (( n = 1 ; n < ${#FUNCNAME[@]} ; ++n )) ; do
+ funcname=${FUNCNAME[${n}]}
+ sourcefile=${BASH_SOURCE[${n}]}
+ lineno=${BASH_LINENO[$(( n - 1 ))]}
+ echo "!!! * ${funcname} (${sourcefile}:${lineno})" 1>&2
+ done
+ echo 1>&2
+
+ if [[ -n "${PALUDIS_EXTRA_DIE_MESSAGE}" ]] ; then
+ echo "${PALUDIS_EXTRA_DIE_MESSAGE}" 1>&2
+ echo 1>&2
+ fi
+
+ kill ${EBUILD_KILL_PID}
+ exit 249
+}
+
+